local E, L, V, P, G, _ = unpack(ElvUI); --Import: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
local CCW = E:GetModule('CustomChannelWarning')
local CH = E:GetModule('Chat')
local LSM = LibStub('LibSharedMedia-3.0')
local EP = LibStub("LibElvUIPlugin-1.0")
local addon, ns = ...

-- Function which monitors custom channels and plays sound
function CCW:MonitorChannels(event, _, author, _, _, _, _, chanID, ...)
	if author == UnitName('player') then return end -- Don't play sound if the message is from yourself
	if event == 'CHAT_MSG_CHANNEL' and chanID == 0 and E.db.CCW.customchannelSound ~= 'None' and not CH.SoundPlayed then
		PlaySoundFile(LSM:Fetch('sound', E.db.CCW.customchannelSound), 'Master')
		CH.SoundPlayed = true
		CH.SoundTimer = CH:ScheduleTimer('ThrottleSound', 1)
	end
end

-- Stuff to do when addon is initialized
function CCW:OnInitialize()
	-- Register our warning function with the channel event
	self:RegisterEvent('CHAT_MSG_CHANNEL', 'MonitorChannels')
	
	-- Register callback with LibElvUIPlugin
	EP:RegisterPlugin(addon, CCW.InsertOptions)
end